blob: cde7fc7fcf355d04708126980d099df820cd00ce [file] [log] [blame]
Jonathan Niederc74c7202013-11-25 13:03:06 -08001# Test framework for git. See t/README for usage.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07002#
3# Copyright (c) 2005 Junio C Hamano
4#
Michal Sojka64b90322010-04-16 15:53:59 +02005# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070017
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070018# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
Felipe Contreras85176d72013-11-17 23:12:43 -050026else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070030fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
Ramkumar Ramachandra2006f0a2012-09-17 22:36:19 +053039################################################################
40# It appears that people try to run tests without building...
41"$GIT_BUILD_DIR/git" >/dev/null
42if test $? != 1
43then
44 echo >&2 'error: you do not seem to have built git yet.'
45 exit 1
46fi
47
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070048. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
49export PERL_PATH SHELL_PATH
50
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +053051# if --tee was passed, write the output not only to the terminal, but
52# additionally to the file test-results/$BASENAME.out, too.
53case "$GIT_TEST_TEE_STARTED, $* " in
54done,*)
55 # do not redirect again
56 ;;
Jeff King452320f2016-10-21 06:48:00 -040057*' --tee '*|*' --va'*|*' --verbose-log '*)
John Keeping2d14e132013-04-29 19:16:21 +010058 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
59 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
Jeff King452320f2016-10-21 06:48:00 -040060
61 # Make this filename available to the sub-process in case it is using
62 # --verbose-log.
63 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
64 export GIT_TEST_TEE_OUTPUT_FILE
65
66 # Truncate before calling "tee -a" to get rid of the results
67 # from any previous runs.
68 >"$GIT_TEST_TEE_OUTPUT_FILE"
69
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +053070 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
Jeff King452320f2016-10-21 06:48:00 -040071 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
Jeff King925bdc92016-10-21 06:42:10 -040072 test "$(cat "$BASE.exit")" = 0
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +053073 exit
74 ;;
75esac
76
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070077# For repeatability, reset the environment to known value.
Richard Hansend5c1b7c2015-06-17 17:11:21 -040078# TERM is sanitized below, after saving color control sequences.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070079LANG=C
Junio C Hamano899460f2005-10-09 21:58:02 -070080LC_ALL=C
Pavel Roskind9bdd392005-08-10 22:10:01 -040081PAGER=cat
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070082TZ=UTC
Richard Hansend5c1b7c2015-06-17 17:11:21 -040083export LANG LC_ALL PAGER TZ
Eric Wong8ff99e72006-07-11 12:01:54 -070084EDITOR=:
Stefano Lattarini661bfd12012-03-02 19:48:36 +010085# A call to "unset" with no arguments causes at least Solaris 10
86# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
87# deriving from the command substitution clustered with the other
88# ones.
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070089unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
Jonathan Nieder95a1d122011-03-15 05:10:45 -050090 my @env = keys %ENV;
Jens Lehmann730477f2011-03-28 21:16:09 +020091 my $ok = join("|", qw(
92 TRACE
93 DEBUG
94 USE_LOOKUP
95 TEST
96 .*_TEST
97 PROVE
98 VALGRIND
René Scharfeac001282013-01-06 18:47:57 +010099 UNZIP
Nguyễn Thái Ngọc Duyedb54082013-01-15 20:50:56 +0700100 PERF_
Jeff Kinge2a0ccc2014-05-22 05:28:50 -0400101 CURL_VERBOSE
Elia Pinto4527aa12016-09-05 10:24:42 +0000102 TRACE_CURL
Jens Lehmann730477f2011-03-28 21:16:09 +0200103 ));
104 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
Jonathan Nieder95a1d122011-03-15 05:10:45 -0500105 print join("\n", @vars);
106')
Jeff King5adf84e2012-07-24 07:53:05 -0400107unset XDG_CONFIG_HOME
Benoit Person8bade1e2013-07-04 22:38:55 +0200108unset GITPERLLIB
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800109GIT_AUTHOR_EMAIL=author@example.com
110GIT_AUTHOR_NAME='A U Thor'
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800111GIT_COMMITTER_EMAIL=committer@example.com
112GIT_COMMITTER_NAME='C O Mitter'
Shawn O. Pearce8d0fc482007-02-04 00:45:47 -0500113GIT_MERGE_VERBOSITY=5
Junio C Hamanof8246282012-01-10 22:44:45 -0800114GIT_MERGE_AUTOEDIT=no
115export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800116export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
117export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
Jonathan Niederd33738d2009-11-11 17:56:07 -0600118export EDITOR
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700119
Karsten Blees124647c2014-07-12 02:03:01 +0200120# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
121GIT_TRACE_BARE=1
122export GIT_TRACE_BARE
123
Thomas Gummerer5d9fc882014-02-23 21:49:58 +0100124if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
125then
126 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
127 export GIT_INDEX_VERSION
128fi
129
Elia Pintoa731fa92012-09-14 09:54:22 -0700130# Add libc MALLOC and MALLOC_PERTURB test
131# only if we are not executing the test with valgrind
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700132if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
René Scharfeee1431b2012-09-26 22:16:39 +0200133 test -n "$TEST_NO_MALLOC_CHECK"
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700134then
135 setup_malloc_check () {
136 : nothing
137 }
138 teardown_malloc_check () {
139 : nothing
140 }
141else
142 setup_malloc_check () {
143 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
144 export MALLOC_CHECK_ MALLOC_PERTURB_
145 }
146 teardown_malloc_check () {
147 unset MALLOC_CHECK_ MALLOC_PERTURB_
148 }
149fi
Elia Pintoa731fa92012-09-14 09:54:22 -0700150
Jeff Kingb0f4c902014-12-08 02:47:06 -0500151: ${ASAN_OPTIONS=detect_leaks=0}
152export ASAN_OPTIONS
153
Junio C Hamano886a3902007-04-24 11:21:47 -0700154# Protect ourselves from common misconfiguration to export
155# CDPATH into the environment
156unset CDPATH
157
Bert Wesarg5565f472009-11-18 17:15:19 +0100158unset GREP_OPTIONS
René Scharfeac001282013-01-06 18:47:57 +0100159unset UNZIP
Bert Wesarg5565f472009-11-18 17:15:19 +0100160
Robin Rosenberg3d5c0cc2006-09-23 00:35:20 +0200161case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001621|2|true)
Jeff King025232e2015-03-13 00:50:56 -0400163 GIT_TRACE=4
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100164 ;;
Christian Couder6ce4e612006-09-02 18:23:48 +0200165esac
166
Junio C Hamanocd3c0952009-09-20 11:10:14 -0700167# Convenience
168#
169# A regexp to match 5 and 40 hexdigits
170_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
171_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
172
Junio C Hamano3749fde2011-04-23 22:34:13 -0700173# Zero SHA-1
174_z40=0000000000000000000000000000000000000000
175
Nguyễn Thái Ngọc Duyf9e7d9f2016-07-16 07:06:24 +0200176EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
Nguyễn Thái Ngọc Duy378932d2016-07-16 07:06:25 +0200177EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
Nguyễn Thái Ngọc Duyf9e7d9f2016-07-16 07:06:24 +0200178
Junio C Hamano3f4ab622011-08-08 11:51:00 -0700179# Line feed
180LF='
181'
182
Jeff Kinga42643a2014-12-15 18:15:20 -0500183# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
184# when case-folding filenames
185u200c=$(printf '\342\200\214')
186
Nguyễn Thái Ngọc Duy378932d2016-07-16 07:06:25 +0200187export _x05 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
Thomas Rast342e9ef2012-02-17 11:25:09 +0100188
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700189# Each test should start with something like this, after copyright notices:
190#
191# test_description='Description of this test...
192# This test checks if command xyzzy does the right thing...
193# '
194# . ./test-lib.sh
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400195test "x$TERM" != "xdumb" && (
Richard Hansenca92a662015-06-17 15:06:25 -0400196 test -t 1 &&
197 tput bold >/dev/null 2>&1 &&
198 tput setaf 1 >/dev/null 2>&1 &&
199 tput sgr0 >/dev/null 2>&1
200 ) &&
201 color=t
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700202
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700203while test "$#" -ne 0
204do
205 case "$1" in
206 -d|--d|--de|--deb|--debu|--debug)
207 debug=t; shift ;;
Junio C Hamano886856a2005-05-14 00:24:27 -0700208 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
209 immediate=t; shift ;;
Lea Wiemann5e2c08c2008-06-17 03:29:02 +0200210 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
Junio C Hamano91e80b92009-02-18 11:17:27 -0800211 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700212 -r)
213 shift; test "$#" -ne 0 || {
214 echo 'error: -r requires an argument' >&2;
215 exit 1;
216 }
217 run_list=$1; shift ;;
218 --run=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200219 run_list=${1#--*=}; shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700220 -h|--h|--he|--hel|--help)
Michele Ballabio570f3222007-11-10 15:17:25 +0100221 help=t; shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700222 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
223 verbose=t; shift ;;
Thomas Rastff09af32013-06-23 20:12:56 +0200224 --verbose-only=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200225 verbose_only=${1#--*=}
Thomas Rastff09af32013-06-23 20:12:56 +0200226 shift ;;
Pierre Habouzit1ece1272007-10-24 22:03:39 +0200227 -q|--q|--qu|--qui|--quie|--quiet)
Ævar Arnfjörð Bjarmason092c4332010-07-31 16:40:05 +0000228 # Ignore --quiet under a TAP::Harness. Saying how many tests
229 # passed without the ok/not ok details is always an error.
230 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700231 --with-dashes)
232 with_dashes=t; shift ;;
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200233 --no-color)
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100234 color=; shift ;;
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100235 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
Thomas Rast952af352013-03-31 10:00:16 +0200236 valgrind=memcheck
237 shift ;;
238 --valgrind=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200239 valgrind=${1#--*=}
Thomas Rast952af352013-03-31 10:00:16 +0200240 shift ;;
Thomas Rast5dfc3682013-06-23 20:12:57 +0200241 --valgrind-only=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200242 valgrind_only=${1#--*=}
Thomas Rast5dfc3682013-06-23 20:12:57 +0200243 shift ;;
Johannes Schindelin44138552009-02-04 00:26:12 +0100244 --tee)
245 shift ;; # was handled already
Jeff Kingf423ef52009-08-09 04:39:45 -0400246 --root=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200247 root=${1#--*=}
Jeff Kingf423ef52009-08-09 04:39:45 -0400248 shift ;;
Jeff Kingbb79af92015-03-20 06:05:48 -0400249 --chain-lint)
250 GIT_TEST_CHAIN_LINT=1
251 shift ;;
252 --no-chain-lint)
253 GIT_TEST_CHAIN_LINT=0
254 shift ;;
Jeff Kinga136f6d2014-10-10 02:47:27 -0400255 -x)
256 trace=t
257 verbose=t
258 shift ;;
Jeff King452320f2016-10-21 06:48:00 -0400259 --verbose-log)
260 verbose_log=t
261 shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700262 *)
Clemens Buchacher1f729dc2009-06-01 14:14:40 +0200263 echo "error: unknown test option '$1'" >&2; exit 1 ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700264 esac
265done
266
Thomas Rast26a07302013-10-19 23:06:07 +0200267if test -n "$valgrind_only"
Thomas Rast5dfc3682013-06-23 20:12:57 +0200268then
269 test -z "$valgrind" && valgrind=memcheck
270 test -z "$verbose" && verbose_only="$valgrind_only"
271elif test -n "$valgrind"
272then
273 verbose=t
274fi
Thomas Rast952af352013-03-31 10:00:16 +0200275
Richard Hansenca92a662015-06-17 15:06:25 -0400276if test -n "$color"
277then
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400278 # Save the color control sequences now rather than run tput
279 # each time say_color() is called. This is done for two
280 # reasons:
281 # * TERM will be changed to dumb
282 # * HOME will be changed to a temporary directory and tput
283 # might need to read ~/.terminfo from the original HOME
284 # directory to get the control sequences
285 # Note: This approach assumes the control sequences don't end
286 # in a newline for any terminal of interest (command
287 # substitutions strip trailing newlines). Given that most
288 # (all?) terminals in common use are related to ECMA-48, this
289 # shouldn't be a problem.
290 say_color_error=$(tput bold; tput setaf 1) # bold red
291 say_color_skip=$(tput setaf 4) # blue
292 say_color_warn=$(tput setaf 3) # brown/yellow
293 say_color_pass=$(tput setaf 2) # green
294 say_color_info=$(tput setaf 6) # cyan
295 say_color_reset=$(tput sgr0)
296 say_color_="" # no formatting for normal text
Richard Hansenca92a662015-06-17 15:06:25 -0400297 say_color () {
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400298 test -z "$1" && test -n "$quiet" && return
299 eval "say_color_color=\$say_color_$1"
Richard Hansenca92a662015-06-17 15:06:25 -0400300 shift
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400301 printf "%s\\n" "$say_color_color$*$say_color_reset"
Richard Hansenca92a662015-06-17 15:06:25 -0400302 }
303else
304 say_color() {
305 test -z "$1" && test -n "$quiet" && return
306 shift
307 printf "%s\n" "$*"
308 }
309fi
310
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400311TERM=dumb
312export TERM
313
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200314error () {
315 say_color error "error: $*"
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200316 GIT_EXIT_OK=t
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200317 exit 1
318}
319
320say () {
321 say_color info "$*"
322}
323
Jeff King614fe012016-10-22 00:45:06 -0400324if test -n "$HARNESS_ACTIVE"
325then
326 if test "$verbose" = t || test -n "$verbose_only"
327 then
328 printf 'Bail out! %s\n' \
329 'verbose mode forbidden under TAP harness; try --verbose-log'
330 exit 1
331 fi
332fi
333
Michele Ballabio570f3222007-11-10 15:17:25 +0100334test "${test_description}" != "" ||
335error "Test script did not set test_description."
336
337if test "$help" = "t"
338then
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100339 printf '%s\n' "$test_description"
Michele Ballabio570f3222007-11-10 15:17:25 +0100340 exit 0
341fi
342
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400343exec 5>&1
Jeff King781f76b2011-12-15 01:55:29 -0500344exec 6<&0
Jeff King452320f2016-10-21 06:48:00 -0400345if test "$verbose_log" = "t"
346then
347 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
348elif test "$verbose" = "t"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700349then
350 exec 4>&2 3>&1
351else
352 exec 4>/dev/null 3>/dev/null
353fi
354
Jeff Kingd88785e2016-05-11 09:44:04 -0400355# Send any "-x" output directly to stderr to avoid polluting tests
356# which capture stderr. We can do this unconditionally since it
357# has no effect if tracing isn't turned on.
358#
359# Note that this sets up the trace fd as soon as we assign the variable, so it
360# must come after the creation of descriptor 4 above. Likewise, we must never
361# unset this, as it has the side effect of closing descriptor 4, which we
362# use to show verbose tests to the user.
363#
364# Note also that we don't need or want to export it. The tracing is local to
365# this shell, and we would not want to influence any shells we exec.
366BASH_XTRACEFD=4
367
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700368test_failure=0
369test_count=0
Junio C Hamano41ac4142008-02-01 01:50:53 -0800370test_fixed=0
371test_broken=0
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +0200372test_success=0
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700373
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000374test_external_has_tap=0
375
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100376die () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200377 code=$?
378 if test -n "$GIT_EXIT_OK"
379 then
380 exit $code
381 else
382 echo >&5 "FATAL: Unexpected exit with code $code"
383 exit 1
384 fi
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100385}
386
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200387GIT_EXIT_OK=
Markus Heidelberg35641312009-01-20 00:43:26 +0100388trap 'die' EXIT
Jeff Kingda706542015-03-13 00:48:48 -0400389trap 'exit $?' INT
Pavel Roskin41184272005-08-11 12:00:40 -0400390
Thomas Rast12a29b12012-02-17 11:25:08 +0100391# The user-facing functions are loaded from a separate file so that
392# test_perf subshells can have them too
Junio C Hamano3c8f12c2012-06-24 22:01:35 -0700393. "$TEST_DIRECTORY/test-lib-functions.sh"
Jonathan Nieder05236a52010-10-17 02:36:58 +0800394
Junio C Hamano886856a2005-05-14 00:24:27 -0700395# You are not expected to call test_ok_ and test_failure_ directly, use
Torstein Hegge3fa36662013-10-27 10:56:33 +0100396# the test_expect_* functions instead.
Junio C Hamano886856a2005-05-14 00:24:27 -0700397
398test_ok_ () {
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100399 test_success=$(($test_success + 1))
Thomas Rast633fe502013-10-19 23:06:08 +0200400 say_color "" "ok $test_count - $@"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700401}
402
Junio C Hamano886856a2005-05-14 00:24:27 -0700403test_failure_ () {
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100404 test_failure=$(($test_failure + 1))
Thomas Rast633fe502013-10-19 23:06:08 +0200405 say_color error "not ok $test_count - $1"
Junio C Hamanobf0dd8a2005-07-22 19:09:34 -0700406 shift
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100407 printf '%s\n' "$*" | sed -e 's/^/# /'
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200408 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
Junio C Hamano886856a2005-05-14 00:24:27 -0700409}
410
Junio C Hamano41ac4142008-02-01 01:50:53 -0800411test_known_broken_ok_ () {
Junio C Hamano41ac4142008-02-01 01:50:53 -0800412 test_fixed=$(($test_fixed+1))
Thomas Rast633fe502013-10-19 23:06:08 +0200413 say_color error "ok $test_count - $@ # TODO known breakage vanished"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800414}
415
416test_known_broken_failure_ () {
Junio C Hamano41ac4142008-02-01 01:50:53 -0800417 test_broken=$(($test_broken+1))
Thomas Rast633fe502013-10-19 23:06:08 +0200418 say_color warn "not ok $test_count - $@ # TODO known breakage"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800419}
Junio C Hamano886856a2005-05-14 00:24:27 -0700420
421test_debug () {
Junio C Hamano8e832eb2005-08-10 22:53:27 -0700422 test "$debug" = "" || eval "$1"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700423}
424
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200425match_pattern_list () {
426 arg="$1"
427 shift
428 test -z "$*" && return 1
429 for pattern_
430 do
431 case "$arg" in
432 $pattern_)
433 return 0
434 esac
435 done
436 return 1
437}
438
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700439match_test_selector_list () {
440 title="$1"
441 shift
442 arg="$1"
443 shift
444 test -z "$1" && return 0
445
446 # Both commas and whitespace are accepted as separators.
447 OLDIFS=$IFS
448 IFS=' ,'
449 set -- $1
450 IFS=$OLDIFS
451
452 # If the first selector is negative we include by default.
453 include=
454 case "$1" in
455 !*) include=t ;;
456 esac
457
458 for selector
459 do
460 orig_selector=$selector
461
462 positive=t
463 case "$selector" in
464 !*)
465 positive=
466 selector=${selector##?}
467 ;;
468 esac
469
470 test -z "$selector" && continue
471
472 case "$selector" in
473 *-*)
474 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
475 then
476 echo "error: $title: invalid non-numeric in range" \
477 "start: '$orig_selector'" >&2
478 exit 1
479 fi
480 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
481 then
482 echo "error: $title: invalid non-numeric in range" \
483 "end: '$orig_selector'" >&2
484 exit 1
485 fi
486 ;;
487 *)
488 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
489 then
490 echo "error: $title: invalid non-numeric in test" \
491 "selector: '$orig_selector'" >&2
492 exit 1
493 fi
494 esac
495
496 # Short cut for "obvious" cases
497 test -z "$include" && test -z "$positive" && continue
498 test -n "$include" && test -n "$positive" && continue
499
500 case "$selector" in
501 -*)
502 if test $arg -le ${selector#-}
503 then
504 include=$positive
505 fi
506 ;;
507 *-)
508 if test $arg -ge ${selector%-}
509 then
510 include=$positive
511 fi
512 ;;
513 *-*)
514 if test ${selector%%-*} -le $arg \
515 && test $arg -le ${selector#*-}
516 then
517 include=$positive
518 fi
519 ;;
520 *)
521 if test $arg -eq $selector
522 then
523 include=$positive
524 fi
525 ;;
526 esac
527 done
528
529 test -n "$include"
530}
531
Thomas Rastff09af32013-06-23 20:12:56 +0200532maybe_teardown_verbose () {
533 test -z "$verbose_only" && return
534 exec 4>/dev/null 3>/dev/null
535 verbose=
536}
537
538last_verbose=t
539maybe_setup_verbose () {
540 test -z "$verbose_only" && return
Thomas Rast26a07302013-10-19 23:06:07 +0200541 if match_pattern_list $test_count $verbose_only
Thomas Rastff09af32013-06-23 20:12:56 +0200542 then
543 exec 4>&2 3>&1
544 # Emit a delimiting blank line when going from
545 # non-verbose to verbose. Within verbose mode the
546 # delimiter is printed by test_expect_*. The choice
547 # of the initial $last_verbose is such that before
548 # test 1, we do not print it.
549 test -z "$last_verbose" && echo >&3 ""
550 verbose=t
551 else
552 exec 4>/dev/null 3>/dev/null
553 verbose=
554 fi
555 last_verbose=$verbose
556}
557
Thomas Rast5dfc3682013-06-23 20:12:57 +0200558maybe_teardown_valgrind () {
559 test -z "$GIT_VALGRIND" && return
560 GIT_VALGRIND_ENABLED=
561}
562
563maybe_setup_valgrind () {
564 test -z "$GIT_VALGRIND" && return
Thomas Rast26a07302013-10-19 23:06:07 +0200565 if test -z "$valgrind_only"
Thomas Rast5dfc3682013-06-23 20:12:57 +0200566 then
567 GIT_VALGRIND_ENABLED=t
568 return
569 fi
570 GIT_VALGRIND_ENABLED=
571 if match_pattern_list $test_count $valgrind_only
572 then
573 GIT_VALGRIND_ENABLED=t
574 fi
575}
576
Jeff King9b5fe782015-08-06 01:33:57 -0400577want_trace () {
578 test "$trace" = t && test "$verbose" = t
579}
580
Jeff Kinga136f6d2014-10-10 02:47:27 -0400581# This is a separate function because some tests use
582# "return" to end a test_expect_success block early
583# (and we want to make sure we run any cleanup like
584# "set +x").
585test_eval_inner_ () {
586 # Do not add anything extra (including LF) after '$*'
587 eval "
Jeff King9b5fe782015-08-06 01:33:57 -0400588 want_trace && set -x
Jeff Kinga136f6d2014-10-10 02:47:27 -0400589 $*"
590}
591
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200592test_eval_ () {
Jeff Kinga136f6d2014-10-10 02:47:27 -0400593 # We run this block with stderr redirected to avoid extra cruft
594 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
595 # the shell from printing the "set +x" to turn it off (nor the saving
596 # of $? before that). But we can make sure that the output goes to
597 # /dev/null.
598 #
599 # The test itself is run with stderr put back to &4 (so either to
600 # /dev/null, or to the original stderr if --verbose was used).
601 {
602 test_eval_inner_ "$@" </dev/null >&3 2>&4
603 test_eval_ret_=$?
Jeff King9b5fe782015-08-06 01:33:57 -0400604 if want_trace
Jeff Kinga136f6d2014-10-10 02:47:27 -0400605 then
606 set +x
607 if test "$test_eval_ret_" != 0
608 then
609 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
610 fi
611 fi
612 } 2>/dev/null
613 return $test_eval_ret_
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200614}
615
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400616test_run_ () {
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500617 test_cleanup=:
Junio C Hamanob5867442011-06-27 11:02:22 -0700618 expecting_failure=$2
Jeff Kingbb79af92015-03-20 06:05:48 -0400619
Jeff King92b269f2015-04-22 16:09:57 -0400620 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
Jeff King2a01ef82015-08-06 01:31:47 -0400621 # turn off tracing for this test-eval, as it simply creates
622 # confusing noise in the "-x" output
623 trace_tmp=$trace
624 trace=
Jeff Kingbb79af92015-03-20 06:05:48 -0400625 # 117 is magic because it is unlikely to match the exit
626 # code of other programs
627 test_eval_ "(exit 117) && $1"
628 if test "$?" != 117; then
629 error "bug in the test script: broken &&-chain: $1"
630 fi
Jeff King2a01ef82015-08-06 01:31:47 -0400631 trace=$trace_tmp
Jeff Kingbb79af92015-03-20 06:05:48 -0400632 fi
633
Thomas Rasta57397b2013-06-17 11:18:46 +0200634 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200635 test_eval_ "$1"
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500636 eval_ret=$?
Thomas Rasta57397b2013-06-17 11:18:46 +0200637 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -0700638
Jeff Kinga136f6d2014-10-10 02:47:27 -0400639 if test -z "$immediate" || test $eval_ret = 0 ||
640 test -n "$expecting_failure" && test "$test_cleanup" != ":"
Junio C Hamanob5867442011-06-27 11:02:22 -0700641 then
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700642 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200643 test_eval_ "$test_cleanup"
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700644 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -0700645 fi
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100646 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
647 then
Ævar Arnfjörð Bjarmason57e15382010-06-24 17:44:47 +0000648 echo ""
649 fi
Jonathan Niederaa0bcf92011-08-08 03:15:34 +0200650 return "$eval_ret"
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400651}
652
Thomas Rastae753422013-06-18 14:25:59 +0200653test_start_ () {
Johannes Sixt8586f982009-02-05 21:20:56 +0100654 test_count=$(($test_count+1))
Thomas Rastff09af32013-06-23 20:12:56 +0200655 maybe_setup_verbose
Thomas Rast5dfc3682013-06-23 20:12:57 +0200656 maybe_setup_valgrind
Thomas Rastae753422013-06-18 14:25:59 +0200657}
658
659test_finish_ () {
660 echo >&3 ""
Thomas Rast5dfc3682013-06-23 20:12:57 +0200661 maybe_teardown_valgrind
Thomas Rastff09af32013-06-23 20:12:56 +0200662 maybe_teardown_verbose
Thomas Rastae753422013-06-18 14:25:59 +0200663}
664
665test_skip () {
Junio C Hamano04ece592006-12-28 17:58:00 -0800666 to_skip=
Ilya Bobyref2ac682014-04-30 02:50:43 -0700667 skipped_reason=
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200668 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
669 then
670 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -0700671 skipped_reason="GIT_SKIP_TESTS"
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200672 fi
Jonathan Nieder05236a52010-10-17 02:36:58 +0800673 if test -z "$to_skip" && test -n "$test_prereq" &&
674 ! test_have_prereq "$test_prereq"
Johannes Sixta7bb3942009-03-01 21:04:46 +0100675 then
676 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -0700677
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500678 of_prereq=
Jonathan Nieder05236a52010-10-17 02:36:58 +0800679 if test "$missing_prereq" != "$test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500680 then
Jonathan Nieder05236a52010-10-17 02:36:58 +0800681 of_prereq=" of $test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500682 fi
Ilya Bobyref2ac682014-04-30 02:50:43 -0700683 skipped_reason="missing $missing_prereq${of_prereq}"
684 fi
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700685 if test -z "$to_skip" && test -n "$run_list" &&
686 ! match_test_selector_list '--run' $test_count "$run_list"
687 then
688 to_skip=t
689 skipped_reason="--run"
690 fi
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500691
Ilya Bobyref2ac682014-04-30 02:50:43 -0700692 case "$to_skip" in
693 t)
Thomas Rast633fe502013-10-19 23:06:08 +0200694 say_color skip >&3 "skipping test: $@"
Ilya Bobyref2ac682014-04-30 02:50:43 -0700695 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
Junio C Hamano04ece592006-12-28 17:58:00 -0800696 : true
697 ;;
698 *)
699 false
700 ;;
701 esac
702}
703
Thomas Rast342e9ef2012-02-17 11:25:09 +0100704# stub; perf-lib overrides it
705test_at_end_hook_ () {
706 :
707}
708
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700709test_done () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200710 GIT_EXIT_OK=t
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +0200711
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100712 if test -z "$HARNESS_ACTIVE"
713 then
Thomas Rast342e9ef2012-02-17 11:25:09 +0100714 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000715 mkdir -p "$test_results_dir"
Felipe Contrerasdd784782012-11-04 03:13:33 +0100716 base=${0##*/}
Jeff King5c885c12016-08-30 04:43:57 -0400717 test_results_path="$test_results_dir/${base%.sh}.counts"
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000718
Jeff King5c885c12016-08-30 04:43:57 -0400719 cat >"$test_results_path" <<-EOF
Mathias Lafeldtc54e6be2011-04-29 14:30:30 +0200720 total $test_count
721 success $test_success
722 fixed $test_fixed
723 broken $test_broken
724 failed $test_failure
725
726 EOF
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000727 fi
Junio C Hamano41ac4142008-02-01 01:50:53 -0800728
729 if test "$test_fixed" != 0
730 then
Thomas Rast633fe502013-10-19 23:06:08 +0200731 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800732 fi
733 if test "$test_broken" != 0
734 then
Thomas Rast633fe502013-10-19 23:06:08 +0200735 say_color warn "# still have $test_broken known breakage(s)"
Adam Spiersb73d9a22012-12-16 18:28:15 +0000736 fi
737 if test "$test_broken" != 0 || test "$test_fixed" != 0
738 then
739 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
740 msg="remaining $test_remaining test(s)"
Junio C Hamano11d54b82008-02-03 00:23:02 -0800741 else
Adam Spiersb73d9a22012-12-16 18:28:15 +0000742 test_remaining=$test_count
Junio C Hamano11d54b82008-02-03 00:23:02 -0800743 msg="$test_count test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800744 fi
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700745 case "$test_failure" in
Junio C Hamano10b94e22005-12-09 17:32:18 -0800746 0)
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000747 # Maybe print SKIP message
Ramsay Jonesbf4b7212012-09-01 19:13:19 +0100748 if test -n "$skip_all" && test $test_count -gt 0
749 then
750 error "Can't use skip_all after running some tests"
751 fi
Richard Hansen46f32a92015-01-06 17:57:50 -0500752 test -z "$skip_all" || skip_all=" # SKIP $skip_all"
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000753
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100754 if test $test_external_has_tap -eq 0
755 then
Adam Spiersb73d9a22012-12-16 18:28:15 +0000756 if test $test_remaining -gt 0
Ramsay Jonesd87bd7c2012-09-01 19:26:21 +0100757 then
Thomas Rast633fe502013-10-19 23:06:08 +0200758 say_color pass "# passed all $msg"
Ramsay Jonesd87bd7c2012-09-01 19:26:21 +0100759 fi
Thomas Rast633fe502013-10-19 23:06:08 +0200760 say "1..$test_count$skip_all"
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000761 fi
Johannes Schindelinabc5d372008-08-08 13:08:37 +0200762
763 test -d "$remove_trash" &&
764 cd "$(dirname "$remove_trash")" &&
765 rm -rf "$(basename "$remove_trash")"
766
Thomas Rast342e9ef2012-02-17 11:25:09 +0100767 test_at_end_hook_
768
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700769 exit 0 ;;
770
771 *)
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100772 if test $test_external_has_tap -eq 0
773 then
Thomas Rast633fe502013-10-19 23:06:08 +0200774 say_color error "# failed $test_failure among $msg"
775 say "1..$test_count"
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000776 fi
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000777
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700778 exit 1 ;;
779
780 esac
781}
782
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700783if test -n "$valgrind"
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100784then
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100785 make_symlink () {
786 test -h "$2" &&
787 test "$1" = "$(readlink "$2")" || {
788 # be super paranoid
789 if mkdir "$2".lock
790 then
791 rm -f "$2" &&
792 ln -s "$1" "$2" &&
793 rm -r "$2".lock
794 else
795 while test -d "$2".lock
796 do
797 say "Waiting for lock on $2."
798 sleep 1
799 done
800 fi
801 }
802 }
803
804 make_valgrind_symlink () {
Jeff King36bfb0e2011-06-17 16:36:32 -0400805 # handle only executables, unless they are shell libraries that
Jonathan Nieder11d62142013-11-25 13:03:52 -0800806 # need to be in the exec-path.
Jeff King36bfb0e2011-06-17 16:36:32 -0400807 test -x "$1" ||
Jonathan Nieder11d62142013-11-25 13:03:52 -0800808 test "# " = "$(head -c 2 <"$1")" ||
Jeff King36bfb0e2011-06-17 16:36:32 -0400809 return;
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100810
811 base=$(basename "$1")
René Scharfe28fab7b2016-10-28 00:14:00 +0200812 case "$base" in
813 test-*)
814 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
815 ;;
816 *)
817 symlink_target="$GIT_BUILD_DIR/$base"
818 ;;
819 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100820 # do not override scripts
821 if test -x "$symlink_target" &&
822 test ! -d "$symlink_target" &&
823 test "#!" != "$(head -c 2 < "$symlink_target")"
824 then
825 symlink_target=../valgrind.sh
826 fi
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100827 case "$base" in
828 *.sh|*.perl)
829 symlink_target=../unprocessed-script
830 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100831 # create the link, or replace it if it is out of date
832 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
833 }
834
Thomas Rast26a07302013-10-19 23:06:07 +0200835 # override all git executables in TEST_DIRECTORY/..
836 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
837 mkdir -p "$GIT_VALGRIND"/bin
Johannes Schindelin503e2242016-07-11 13:45:08 +0200838 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
Thomas Rast26a07302013-10-19 23:06:07 +0200839 do
840 make_valgrind_symlink $file
841 done
842 # special-case the mergetools loadables
843 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
844 OLDIFS=$IFS
845 IFS=:
846 for path in $PATH
847 do
848 ls "$path"/git-* 2> /dev/null |
849 while read file
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100850 do
Thomas Rast26a07302013-10-19 23:06:07 +0200851 make_valgrind_symlink "$file"
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100852 done
Thomas Rast26a07302013-10-19 23:06:07 +0200853 done
854 IFS=$OLDIFS
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100855 PATH=$GIT_VALGRIND/bin:$PATH
856 GIT_EXEC_PATH=$GIT_VALGRIND/bin
857 export GIT_VALGRIND
Thomas Rast952af352013-03-31 10:00:16 +0200858 GIT_VALGRIND_MODE="$valgrind"
859 export GIT_VALGRIND_MODE
Thomas Rast5dfc3682013-06-23 20:12:57 +0200860 GIT_VALGRIND_ENABLED=t
Thomas Rast26a07302013-10-19 23:06:07 +0200861 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
Thomas Rast5dfc3682013-06-23 20:12:57 +0200862 export GIT_VALGRIND_ENABLED
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100863elif test -n "$GIT_TEST_INSTALLED"
864then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700865 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
866 error "Cannot run git from $GIT_TEST_INSTALLED."
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000867 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700868 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
869else # normal case, use ../bin-wrappers only unless $with_dashes:
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000870 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100871 if ! test -x "$git_bin_dir/git"
872 then
873 if test -z "$with_dashes"
874 then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700875 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
876 fi
877 with_dashes=t
878 fi
879 PATH="$git_bin_dir:$PATH"
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000880 GIT_EXEC_PATH=$GIT_BUILD_DIR
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100881 if test -n "$with_dashes"
882 then
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000883 PATH="$GIT_BUILD_DIR:$PATH"
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700884 fi
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100885fi
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000886GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
Jeff King8bfa6bd2008-02-06 05:11:53 -0500887GIT_CONFIG_NOSYSTEM=1
Jonathan Nieder3c995be2011-03-15 04:05:10 -0500888GIT_ATTR_NOSYSTEM=1
Jonathan Nieder8f323c02011-03-15 04:04:49 -0500889export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
Junio C Hamano49ccb082005-12-07 21:52:28 -0800890
Junio C Hamano5e87eae2010-06-11 09:40:25 -0700891if test -z "$GIT_TEST_CMP"
892then
893 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
894 then
895 GIT_TEST_CMP="$DIFF -c"
896 else
897 GIT_TEST_CMP="$DIFF -u"
898 fi
899fi
900
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000901GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
Petr Baudis6fcca932006-07-03 23:16:32 +0200902export GITPERLLIB
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000903test -d "$GIT_BUILD_DIR"/templates/blt || {
Junio C Hamanoeea42062005-12-10 20:55:32 -0800904 error "You haven't built things yet, have you?"
905}
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700906
Nguyễn Thái Ngọc Duye6e75302016-04-13 20:22:42 +0700907if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100908then
Eric Wong56cf9802007-02-24 16:59:52 -0800909 echo >&2 'You need to build test-chmtime:'
Nguyễn Thái Ngọc Duye6e75302016-04-13 20:22:42 +0700910 echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
Eric Wong56cf9802007-02-24 16:59:52 -0800911 exit 1
912fi
913
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700914# Test repository
Jeff King002d4ce2013-04-14 15:38:21 -0400915TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
916test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
917case "$TRASH_DIRECTORY" in
918/*) ;; # absolute path is good
919 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
Jeff Kingf423ef52009-08-09 04:39:45 -0400920esac
Jeff King91c8b822009-08-09 04:38:11 -0400921test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
John Keeping38b074d2013-04-14 17:34:56 +0100922rm -fr "$TRASH_DIRECTORY" || {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200923 GIT_EXIT_OK=t
Junio C Hamano8d14ac92008-03-18 21:58:01 -0700924 echo >&5 "FATAL: Cannot prepare test area"
925 exit 1
926}
927
Alex Riesen90cff962011-03-26 19:46:34 +0100928HOME="$TRASH_DIRECTORY"
Junio C Hamano0ea47f92014-09-15 14:59:00 -0700929GNUPGHOME="$HOME/gnupg-home-not-used"
930export HOME GNUPGHOME
Alex Riesen90cff962011-03-26 19:46:34 +0100931
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100932if test -z "$TEST_NO_CREATE_REPO"
933then
John Keeping38b074d2013-04-14 17:34:56 +0100934 test_create_repo "$TRASH_DIRECTORY"
Thomas Rast342e9ef2012-02-17 11:25:09 +0100935else
John Keeping38b074d2013-04-14 17:34:56 +0100936 mkdir -p "$TRASH_DIRECTORY"
Thomas Rast342e9ef2012-02-17 11:25:09 +0100937fi
Lea Wiemann1bd9c642008-05-31 23:11:21 +0200938# Use -P to resolve symlinks in our working directory so that the cwd
939# in subprocesses like git equals our $PWD (for pathname comparisons).
John Keeping38b074d2013-04-14 17:34:56 +0100940cd -P "$TRASH_DIRECTORY" || exit 1
Junio C Hamano04ece592006-12-28 17:58:00 -0800941
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100942this_test=${0##*/}
943this_test=${this_test%%-*}
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200944if match_pattern_list "$this_test" $GIT_SKIP_TESTS
945then
946 say_color info >&3 "skipping test $this_test altogether"
947 skip_all="skip all tests in $this_test"
948 test_done
949fi
Johannes Sixtf17e9fb2009-03-11 21:17:26 +0100950
Brandon Casey86487322009-08-28 17:32:41 -0500951# Provide an implementation of the 'yes' utility
952yes () {
953 if test $# = 0
954 then
955 y=y
956 else
957 y="$*"
958 fi
959
Johannes Schindelin6129c932016-02-02 19:15:53 +0100960 i=0
961 while test $i -lt 99
Brandon Casey86487322009-08-28 17:32:41 -0500962 do
Johannes Schindelin6129c932016-02-02 19:15:53 +0100963 echo "$y"
964 i=$(($i+1))
Brandon Casey86487322009-08-28 17:32:41 -0500965 done
966}
967
Johannes Sixtf17e9fb2009-03-11 21:17:26 +0100968# Fix some commands on Windows
969case $(uname -s) in
970*MINGW*)
971 # Windows has its own (incompatible) sort and find
972 sort () {
973 /usr/bin/sort "$@"
974 }
975 find () {
976 /usr/bin/find "$@"
977 }
Johannes Sixt5397ea32009-03-14 22:21:27 +0100978 sum () {
979 md5sum "$@"
980 }
Johannes Sixt41141562009-03-13 23:35:24 +0100981 # git sees Windows-style pwd
982 pwd () {
983 builtin pwd -W
984 }
Johannes Sixtee9fb682009-03-13 22:55:27 +0100985 # no POSIX permissions
Johannes Sixt6fd11062009-03-13 23:00:15 +0100986 # backslashes in pathspec are converted to '/'
Johannes Sixtfb9a2be2009-03-25 13:21:15 +0100987 # exec does not inherit the PID
Pat Thoytsa94114a2010-09-12 10:37:24 +0100988 test_set_prereq MINGW
Brice Lambson5f4e02e2014-08-30 23:39:07 +0200989 test_set_prereq NATIVE_CRLF
Ramsay Jonesa31d0662010-12-14 18:32:12 +0000990 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -0400991 test_set_prereq GREP_STRIPS_CR
Johannes Sixt4d715ac2013-10-26 21:17:15 +0200992 GIT_TEST_CMP=mingw_test_cmp
Ramsay Jonesa31d0662010-12-14 18:32:12 +0000993 ;;
994*CYGWIN*)
995 test_set_prereq POSIXPERM
Ramsay Jonesa31d0662010-12-14 18:32:12 +0000996 test_set_prereq EXECKEEPSPID
Pete Wyckoffcfa96492013-01-26 22:11:11 -0500997 test_set_prereq CYGWIN
Ramsay Jonesa31d0662010-12-14 18:32:12 +0000998 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -0400999 test_set_prereq GREP_STRIPS_CR
Johannes Sixtee9fb682009-03-13 22:55:27 +01001000 ;;
1001*)
1002 test_set_prereq POSIXPERM
Johannes Sixt6fd11062009-03-13 23:00:15 +01001003 test_set_prereq BSLASHPSPEC
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001004 test_set_prereq EXECKEEPSPID
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001005 ;;
1006esac
Johannes Sixt704a3142009-03-04 22:38:24 +01001007
Zbigniew Jędrzejewski-Szmekb0826872012-04-27 11:25:25 +02001008( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
Jeff King1b19ccd2009-04-03 15:33:59 -04001009test -z "$NO_PERL" && test_set_prereq PERL
Johan Herlandd4e1b472009-11-18 02:42:31 +01001010test -z "$NO_PYTHON" && test_set_prereq PYTHON
Michał Kiedrowicz8f852ce2011-05-09 23:52:07 +02001011test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
Ævar Arnfjörð Bjarmason5e9637c2011-11-18 00:14:42 +01001012test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
Jeff King1b19ccd2009-04-03 15:33:59 -04001013
Ævar Arnfjörð Bjarmasonbb946bb2011-02-22 23:41:21 +00001014# Can we rely on git's output in the C locale?
Jonathan Nieder30955222011-02-22 23:41:22 +00001015if test -n "$GETTEXT_POISON"
1016then
1017 GIT_GETTEXT_POISON=YesPlease
1018 export GIT_GETTEXT_POISON
Ævar Arnfjörð Bjarmason5e9637c2011-11-18 00:14:42 +01001019 test_set_prereq GETTEXT_POISON
Jonathan Nieder30955222011-02-22 23:41:22 +00001020else
1021 test_set_prereq C_LOCALE_OUTPUT
1022fi
Ævar Arnfjörð Bjarmasonbb946bb2011-02-22 23:41:21 +00001023
Junio C Hamanocabdee22011-04-12 11:23:23 -07001024# Use this instead of test_cmp to compare files that contain expected and
1025# actual output from git commands that can be translated. When running
1026# under GETTEXT_POISON this pretends that the command produced expected
1027# results.
1028test_i18ncmp () {
1029 test -n "$GETTEXT_POISON" || test_cmp "$@"
1030}
1031
Junio C Hamano127df8c2011-04-12 15:57:08 -07001032# Use this instead of "grep expected-string actual" to see if the
1033# output from a git command that can be translated either contains an
1034# expected string, or does not contain an unwanted one. When running
1035# under GETTEXT_POISON this pretends that the command produced expected
1036# results.
1037test_i18ngrep () {
1038 if test -n "$GETTEXT_POISON"
1039 then
1040 : # pretend success
1041 elif test "x!" = "x$1"
1042 then
1043 shift
1044 ! grep "$@"
1045 else
1046 grep "$@"
1047 fi
1048}
1049
Adam Spiers20073272013-04-11 03:07:04 +01001050test_lazy_prereq PIPE '
1051 # test whether the filesystem supports FIFOs
Mark Levedahl94436052013-07-04 18:04:30 -04001052 case $(uname -s) in
Johannes Schindelina1f32962016-01-27 17:19:43 +01001053 CYGWIN*|MINGW*)
Mark Levedahl94436052013-07-04 18:04:30 -04001054 false
1055 ;;
1056 *)
1057 rm -f testfifo && mkfifo testfifo
1058 ;;
1059 esac
Adam Spiers20073272013-04-11 03:07:04 +01001060'
1061
Junio C Hamano04083f22012-07-26 15:50:45 -07001062test_lazy_prereq SYMLINKS '
1063 # test whether the filesystem supports symbolic links
1064 ln -s x y && test -h y
1065'
Ævar Arnfjörð Bjarmasonc91cfd12010-08-06 22:09:09 +00001066
Jonathan Niederb018c732013-11-25 13:02:16 -08001067test_lazy_prereq FILEMODE '
1068 test "$(git config --bool core.filemode)" = true
1069'
1070
Michael J Gruberac39aa62012-07-26 15:39:53 +02001071test_lazy_prereq CASE_INSENSITIVE_FS '
1072 echo good >CamelCase &&
1073 echo bad >camelcase &&
1074 test "$(cat CamelCase)" != good
1075'
1076
Michael J Gruber5b0b5dd2012-07-26 15:39:56 +02001077test_lazy_prereq UTF8_NFD_TO_NFC '
1078 # check whether FS converts nfd unicode to nfc
1079 auml=$(printf "\303\244")
1080 aumlcdiar=$(printf "\141\314\210")
1081 >"$auml" &&
1082 case "$(echo *)" in
1083 "$aumlcdiar")
1084 true ;;
1085 *)
1086 false ;;
1087 esac
1088'
1089
Jeff King09feffb2012-11-14 16:33:40 -08001090test_lazy_prereq AUTOIDENT '
1091 sane_unset GIT_AUTHOR_NAME &&
1092 sane_unset GIT_AUTHOR_EMAIL &&
1093 git var GIT_AUTHOR_IDENT
1094'
1095
Junio C Hamano6219bb22014-06-09 12:23:30 -07001096test_lazy_prereq EXPENSIVE '
1097 test -n "$GIT_TEST_LONG"
1098'
1099
Junio C Hamanoe1ecd9e2014-06-09 13:54:25 -07001100test_lazy_prereq USR_BIN_TIME '
1101 test -x /usr/bin/time
1102'
1103
Jeff King1767c512015-01-16 04:16:49 -05001104test_lazy_prereq NOT_ROOT '
1105 uid=$(id -u) &&
1106 test "$uid" != 0
1107'
1108
Jonathan Tan63b747c2016-09-09 10:36:28 -07001109test_lazy_prereq JGIT '
1110 type jgit
1111'
1112
Junio C Hamano719c3da2016-01-19 14:09:37 -08001113# SANITY is about "can you correctly predict what the filesystem would
1114# do by only looking at the permission bits of the files and
1115# directories?" A typical example of !SANITY is running the test
1116# suite as root, where a test may expect "chmod -r file && cat file"
1117# to fail because file is supposed to be unreadable after a successful
1118# chmod. In an environment (i.e. combination of what filesystem is
1119# being used and who is running the tests) that lacks SANITY, you may
1120# be able to delete or create a file when the containing directory
1121# doesn't have write permissions, or access a file even if the
1122# containing directory doesn't have read or execute permissions.
1123
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001124test_lazy_prereq SANITY '
1125 mkdir SANETESTD.1 SANETESTD.2 &&
1126
1127 chmod +w SANETESTD.1 SANETESTD.2 &&
1128 >SANETESTD.1/x 2>SANETESTD.2/x &&
1129 chmod -w SANETESTD.1 &&
Junio C Hamano719c3da2016-01-19 14:09:37 -08001130 chmod -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001131 chmod -rx SANETESTD.2 ||
1132 error "bug in test sript: cannot prepare SANETESTD"
1133
Junio C Hamano719c3da2016-01-19 14:09:37 -08001134 ! test -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001135 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1136 status=$?
1137
1138 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1139 rm -rf SANETESTD.1 SANETESTD.2 ||
1140 error "bug in test sript: cannot clean SANETESTD"
1141 return $status
1142'
Jeff Kingf838ce52013-03-10 21:31:47 -04001143
1144GIT_UNZIP=${GIT_UNZIP:-unzip}
1145test_lazy_prereq UNZIP '
1146 "$GIT_UNZIP" -v
1147 test $? -ne 127
1148'
Jeff King9a308de2015-03-13 00:53:07 -04001149
1150run_with_limited_cmdline () {
1151 (ulimit -s 128 && "$@")
1152}
1153
1154test_lazy_prereq CMDLINE_LIMIT 'run_with_limited_cmdline true'
Jeff King6b9c38e2016-07-11 19:54:18 -04001155
1156build_option () {
1157 git version --build-options |
1158 sed -ne "s/^$1: //p"
1159}
1160
1161test_lazy_prereq LONG_IS_64BIT '
1162 test 8 -le "$(build_option sizeof-long)"
1163'